/*
 * Programming in Java, Jacobs University, 2015
 *
 * This file demonstrates the usage of algorithms provided by the
 * Collections class such as sort, reverse, shuffle, min, max.
 */

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.SortedSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.TreeSet;
import java.util.Arrays;

class C
{

    public static void add(Collection<String> c, String[] args)
    {
	for (String s: args) {
	    c.add(s);
	}
    }

    public static void print(Collection<String> c)
    {
	System.out.print(c.getClass().getName() + ":\t");
	for (String s: c) {
	    System.out.print(" " + s);
	}
	System.out.println();
    }

    public static void sets(String[] args)
    {
	// hash table set
	Set<String> aSet = new HashSet<String>();
	add(aSet, args);
	print(aSet);

	// sorted set using a sorted tree and default comparison
	SortedSet<String> aSortedSet = new TreeSet<String>();
	add(aSortedSet, args);
	print(aSortedSet);
    }

    public static void lists(String[] args)
    {
	List<String> aList;

	// array list
	aList = new ArrayList<String>();
	add(aList, args);
	print(aList);

	// doubly linked list
	aList = new LinkedList<String>();
	add(aList, args);
	print(aList);
	
    }

    public static void collections(String[] args)
    {
	List<String> aList = Arrays.asList(args);

	print(aList);
	Collections.sort(aList);
	print(aList);
	Collections.reverse(aList);
	print(aList);
	Collections.shuffle(aList);
	print(aList);

	System.out.println("min:\t" + Collections.min(aList));
	System.out.println("max:\t" + Collections.max(aList));

	for (String e: aList) {
	    System.out.println("freq(" + e + "):\t" 
			       + Collections.frequency(aList, e));
	}
    }

    public static void main(String[] args)
    {
	lists(args);
	sets(args);

	collections(args);
    }
}
